(function ($) {
    if (typeof(String.prototype.trim) === "undefined") {
        String.prototype.trim = function () {
            return String(this).replace(/^\s+|\s+$/g, '');
        };
    }
    function debug(t) {
        if (console && console.log) {
            console.log(t)
        } else {
            alert('Console não habilitado!!!')
        }
    }

    $(document)
        .ready(function () {
            var $e_entrada = $('#e_entrada'),
                $e_btn_visualizar = $('#e_btn_visualizar'),
                $e_saida = $('#e_saida'),
                $e_btn_apagar = $('#e_btn_apagar'),
                $e_btn_desfazer = $('#e_btn_desfazer'),
                $e_historico = $('#e_historico');

            // ***********************************************************
            // processamento
            // ***********************************************************

            function f_add_historico (texto) {
                // gera a tag <li> do historico

                debug('f_add_historico: inicio');
                if (texto){
                    // se antes havia um 'li.text-muted'...
                    if ($e_historico.find('li.text-muted').length){
                        // ...remove o 'li.text-muted'
                        $e_historico.empty();
                    }

                    // adiciona o novo texto no TOPO
                    // bloco HTML
                    $e_historico
                        .prepend(
                            '<li>' + texto + '</li>'
                        );

                    // libera o botão de 'desfazer'
                    $e_btn_desfazer
                        .removeClass('disabled')
                        .removeAttr('disabled');
                }
                debug('f_add_historico: fim');
            }

            function f_del_historico () {
                // remove a tag <li> do historico

                debug('f_del_historico: inicio');
                var old_hist = '';

                // checa se possui algum texto...
                if ($e_historico.find('li:not(.text-muted)').length){
                    // pega o ultimo
                    var $hist = $e_historico.find('li:not(.text-muted):first');

                    // recupera o texto
                    old_hist = $hist.html().trim();

                    // apaga o ultimo historico
                    $hist.remove();

                    // se era o ultimo elemento...
                    if (!$e_historico.find('li').length){
                        // ...então adiciona o 'li.text-muted'
                        $e_historico
                            .append(
                                '<li class="text-muted">(em branco)</li>'
                            )
                    }
                }

                if ($e_historico.find('li.text-muted').length){
                    // desativa o botão 'desfazer'
                    $e_btn_desfazer
                        .addClass('disabled')
                        .attr('disabled', 'disabled');
                }

                debug('f_del_historico: fim');
                return old_hist;
            }

            function f_escreve_na_saida (texto) {
                debug('f_escreve_na_saida: inicio');
                debug('f_escreve_na_saida: txt novo' + (texto || "[em branco]"));

                // 'pega' o valor que havia na E_SAIDA
                var saida_antiga = $e_saida.html().trim();

                // adiciona o novo texto
                $e_saida
                    .html(texto);

                // habilita o botão de APAGAR?
                if (texto) {
                    $e_btn_apagar
                        .removeClass('disabled')
                        .removeAttr('disabled');
                } else {
                    $e_btn_apagar
                        .addClass('disabled')
                        .attr('disabled', 'disabled');
                }

                debug('f_escreve_na_saida, txt antigo: ' + (saida_antiga || ''));
                debug('f_escreve_na_saida: fim');

                return saida_antiga || '';
            }

            function f_processa_entrada () {
                debug('f_processa_entrada: inicio');
                var texto = $e_entrada.val() || '';

                $e_entrada.val('');             // limpa 'entrada'

                if (texto) {
                    f_add_historico(
                        f_escreve_na_saida(texto)
                    );
                } else {
                    alert('Nada foi digitado =(');
                }

                debug('f_processa_entrada: fim');
            }
            // ***********************************************************
            // eventos
            // ***********************************************************
            f_e_entrada_keyup = function (e) {
                debug('f_e_entrada_keyup: inicio');

                // se o ENTER for pressionado...
                if (e.which == 13){

                    // ...processa o texto digitado
                    f_processa_entrada();
                }

                debug('f_e_entrada_keyup: fim');
            };

            f_e_btn_visualizar_click = function (e) {
                    debug('f_e_btn_visualizar_click: inicio');

                    // processa o texto digitado
                    f_processa_entrada();

                    debug('f_e_btn_visualizar_click: fim');
            };

            f_e_btn_apagar_click = function (e) {
                debug('f_e_btn_apagar_click: inicio');

                if (
                    $e_btn_apagar.hasClass('.disabled')
                    || $e_btn_apagar.is('[disabled]')
                ) {
                   // nao faz nada
                } else {
                    // se o botão está ativo, deve ter algo lá na SAIDA

                    // então, escrevo um 'nada'
                    // e
                    // adiciono o retorno do texto da 'saida' no histórico
                    f_add_historico(
                        f_escreve_na_saida('')
                    );
                }

                debug('f_e_btn_apagar_click: fim');
            };

            f_e_btn_desfazer_click = function (e) {
                debug('f_e_btn_desfazer_click: inicio');

                f_escreve_na_saida(
                    f_del_historico()
                );

                debug('f_e_btn_desfazer_click: fim');
            }
        });
})(jQuery);